---
title: List ownership inferences for a resource
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > CSM Ownership
---

# List ownership inferences for a resource{% #list-ownership-inferences-for-a-resource %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                         |
| ----------------- | -------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/csm/ownership/{resource_id} |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/csm/ownership/{resource_id} |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/csm/ownership/{resource_id}      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/csm/ownership/{resource_id}      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/csm/ownership/{resource_id}  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/csm/ownership/{resource_id}     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/csm/ownership/{resource_id} |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/csm/ownership/{resource_id} |

### Overview

Get all current ownership inferences for a resource, one per owner type (`user`, `team`, `service`, `unknown`).

### Arguments

#### Path Parameters

| Name                          | Type   | Description                                                          |
| ----------------------------- | ------ | -------------------------------------------------------------------- |
| resource_id [*required*] | string | The identifier of the resource to retrieve ownership inferences for. |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response returned when listing all current ownership inferences for a resource.

| Parent field | Field                               | Type      | Description                                                                                                                                              |
| ------------ | ----------------------------------- | --------- | -------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]              | object    | The data wrapper for the ownership inferences collection response.                                                                                       |
| data         | attributes [*required*]        | object    | The attributes of the ownership inferences collection response.                                                                                          |
| attributes   | items [*required*]             | [object]  | The list of inferences for a resource, with one inference per owner type.                                                                                |
| items        | checksum [*required*]          | string    | A checksum that uniquely identifies the current state of the inference. Required when submitting feedback.                                               |
| items        | confidence [*required*]        | string    | The confidence score of the inference, expressed as a numeric string with up to four decimal places.                                                     |
| items        | created_at [*required*]        | date-time | The time when the inference was created.                                                                                                                 |
| items        | evidence_versions [*required*] | [object]  | The list of evidence versions associated with an inference.                                                                                              |
| items        | explanation [*required*]       | string    | A human-readable explanation of how the inference was produced.                                                                                          |
| items        | id [*required*]                | string    | The identifier of the inference, formatted as `resource_id:owner_type`.                                                                                  |
| items        | owner_type [*required*]        | enum      | The owner type for an ownership inference. Allowed enum values: `user,team,service,unknown`                                                              |
| items        | primary_contact_ref                 | string    | The primary contact reference for the inferred owner, formatted as `ref:handle/<owner_handle>`.                                                          |
| items        | sources [*required*]           | [object]  | The list of sources backing an ownership inference. Empty when the inference status is not whitelisted to expose sources.                                |
| items        | status [*required*]            | enum      | The lifecycle status of an ownership inference. Allowed enum values: `suggested,persisted,overridden,failed,unknown`                                     |
| items        | updated_at [*required*]        | date-time | The time when the inference was last updated.                                                                                                            |
| data         | id [*required*]                | string    | The resource identifier associated with the returned inferences.                                                                                         |
| data         | type [*required*]              | enum      | The type of the ownership inferences collection resource. The value should always be `ownership_inferences`. Allowed enum values: `ownership_inferences` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "items": [
        {
          "checksum": "abc123",
          "confidence": "0.9500",
          "created_at": "2026-01-15T10:00:00Z",
          "evidence_versions": [
            []
          ],
          "explanation": "High confidence match",
          "id": "test-resource:team",
          "owner_type": "team",
          "primary_contact_ref": "ref:handle/team-a",
          "sources": [
            []
          ],
          "status": "suggested",
          "updated_at": "2026-01-15T10:00:00Z"
        }
      ]
    },
    "id": "test-resource",
    "type": "ownership_inferences"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export resource_id="test-resource" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/csm/ownership/${resource_id}" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
List ownership inferences for a resource returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.csm_ownership_api import CSMOwnershipApi

configuration = Configuration()
configuration.unstable_operations["list_ownership_inferences"] = True
with ApiClient(configuration) as api_client:
    api_instance = CSMOwnershipApi(api_client)
    response = api_instance.list_ownership_inferences(
        resource_id="test-resource",
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# List ownership inferences for a resource returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.list_ownership_inferences".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CSMOwnershipAPI.new
p api_instance.list_ownership_inferences("test-resource")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// List ownership inferences for a resource returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.ListOwnershipInferences", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCSMOwnershipApi(apiClient)
	resp, r, err := api.ListOwnershipInferences(ctx, "test-resource")

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CSMOwnershipApi.ListOwnershipInferences`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CSMOwnershipApi.ListOwnershipInferences`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// List ownership inferences for a resource returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CsmOwnershipApi;
import com.datadog.api.client.v2.model.OwnershipInferenceListResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.listOwnershipInferences", true);
    CsmOwnershipApi apiInstance = new CsmOwnershipApi(defaultClient);

    try {
      OwnershipInferenceListResponse result = apiInstance.listOwnershipInferences("test-resource");
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CsmOwnershipApi#listOwnershipInferences");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// List ownership inferences for a resource returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_csm_ownership::CSMOwnershipAPI;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.ListOwnershipInferences", true);
    let api = CSMOwnershipAPI::with_config(configuration);
    let resp = api
        .list_ownership_inferences("test-resource".to_string())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * List ownership inferences for a resource returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.listOwnershipInferences"] = true;
const apiInstance = new v2.CSMOwnershipApi(configuration);

const params: v2.CSMOwnershipApiListOwnershipInferencesRequest = {
  resourceId: "test-resource",
};

apiInstance
  .listOwnershipInferences(params)
  .then((data: v2.OwnershipInferenceListResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
